source: BOL/script_install/install_lmdz.sh @ 4515

Last change on this file since 4515 was 4508, checked in by asima, 17 months ago

Do "gmake" in IOIPSL/rebuild folder if this folder exists - which is the case for IOIPSLv_2_2_5 (in IOIPSLv2_2_2, the rebuild files were in IOIPSL/tools)

  • Property svn:executable set to *
File size: 57.1 KB
Line 
1#!/bin/bash
2
3#set -vx
4
5###########################################################################
6# Author : Laurent Fairhead et Frédéric Hourdin
7# Usage  : install_lmdz.sh -help
8#
9# bash installation script of the LMDZ model on different computer types :
10# Linux PC, "mesocentre" (IPSL-UPMC, IPSL-X), super-computer (IDRIS)
11#
12# The model is downloaded in the following directory tree
13# $MODEL/modipsl/modeles/...
14# using the "modipsl" infrastructure created by the "IPSL"
15# for coupled (atmosphere/ocean/vegetation/chemistry) climate modeling
16# activities.
17# Here we only download atmospheric (LMDZ) and vegetation (ORCHIDEE)
18# components.
19#
20# The sources of the models can be found in the "modeles" directory.
21# In the present case, LMDZ, ORCHIDEE, and IOIPSL or XIOS (handling of
22# input-outputs using the NetCDF library).
23#
24# The script downloads various source files (including a version of NetCDF)
25# and utilities, compiles the model, and runs a test simulation in a
26# minimal configuration.
27#
28# Prerequisites : pgf90/gfortran, bash or ksh, wget , gunzip, tar, ...
29#
30# Modif 18/11/2011
31#    changes for option real 8.
32#      We compile with -r8 (or equivalent) and -DNC_DOUBLE for the GCM
33#      but with -r4 for netcdf. Variable real must be set to
34#      r4 or r8 at the beginning of the script below.
35#
36###########################################################################
37
38echo install_lmdz.sh DEBUT `date`
39set -e
40
41################################################################
42# Choice of installation options
43################################################################
44
45################################################################
46# A function to fetch files either locally or on the internet
47################################################################
48function myget { #1st and only argument should be file name
49    # Path on local computer where to look for the datafile
50    if [ -f /u/lmdz/WWW/LMDZ/pub/$1 ] ; then
51        \cp -f -p /u/lmdz/WWW/LMDZ/pub/$1 .
52    elif [ -f ~/LMDZ/pub/$1 ] ; then
53        \cp -f -p ~/LMDZ/pub/$1 .
54    else
55        wget --no-check-certificate -nv http://lmdz.lmd.jussieu.fr/pub/$1
56        save_pub_locally=0
57        if [ $save_pub_locally = 1 ] ; then # saving wget files on ~/LMDZ/pub
58            dir=~/LMDZ/pub/`dirname $1` ; mkdir -p $dir
59            cp -r `basename $1` $dir
60        fi
61    fi
62}
63
64# 04_2021 : tester si r4 marche encore !
65#real=r4
66real=r8
67
68
69#########################################################################
70# Valeur par défaut des parametres
71#########################################################################
72svn=""
73#version=trunk
74version=20221201.trunk
75
76getlmdzor=1
77netcdf=1   #  1: for automatic installation;
78#          or 0: do not install NetCDF and look for it in standard locations;
79#          or absolute path: look for NetCDF there
80check_linux=1
81ioipsl=1
82bench=1
83pclinux=1
84pcmac=0 # default: not on a Mac
85compiler=gfortran
86if [ `gfortran -dumpversion | cut -d. -f1` -ge 11 ] ; then allow_arg_mismatch="-fallow-argument-mismatch" ; fi
87SCM=0
88# surface/vegetation scheme treatment
89# controlled by the single variable veget which can have the following values
90# - NONE: bucket scheme (default)
91# - CMIP6: orchidee version used in CMIP exercise, rev 5661
92# - number: orchidee version number
93veget=NONE
94# choose the resolution for the bench runs
95# grid_resolution= 32x24x11 or 48x36x19 for tests (test without ORCHIDEE)
96#                  96x71x19  standard configuration
97grid_resolution=144x142x79
98grid_resolution=96x95x39
99grid_resolution=48x36x19
100grid_resolution=32x32x39
101# choose the physiq version you want to test
102#physiq=NPv6.0.14splith
103physiq=
104
105## parallel can take the values none/mpi/omp/mpi_omp
106parallel=mpi_omp
107parallel=none
108idris_acct=lmd
109trusting=testing
110OPT_GPROF=""
111OPT_MAKELMDZ=""
112MODEL=""
113
114## also compile XIOS? (and more recent NetCDF/HDF5 libraries) Default=no
115with_xios="n"
116opt_makelmdz_xios=""
117
118## compile with oldrad/rrtm/ecrad radiatif code (Default=rrtm)
119rad=rrtm
120
121## compile_with_fcm=1 : use makelmdz_fcm (1) or makelmdz (0)
122compile_with_fcm=1
123
124#Compilation with Cosp (cosp=NONE/v1/v2 ; default=NONE)
125cosp=NONE
126opt_cosp=""
127
128# Check if on a Mac
129if [ `uname` = "Darwin" ]
130then
131    pcmac=1
132    export MAKE=make
133fi
134#echo "pcmac="$pcmac
135
136env_file=""
137
138#########################################################################
139#  Options interactives
140#########################################################################
141while (($# > 0))
142do
143    case $1 in
144        "-h") cat <<........fin
145    $0 [ -v version ] [ -r svn_release ]
146           [ -parallel PARA ] [ -d GRID_RESOLUTION ] [ -bench 0/1 ]
147           [-name LOCAL_MODEL_NAME] [-gprof] [-opt_makelmdz] [-rad RADIATIF]
148
149    -v       "version" like 20150828.trunk
150             see http://www.lmd.jussieu.fr/~lmdz/Distrib/LISMOI.trunk
151
152    -r       "svn_release" : either the svn release number or "last"
153
154    -compiler gfortran|ifort|pgf90 (default: gfortran)
155
156    -parallel PARA : can be mpi_omp (mpi with openMP) or none (for sequential)
157
158    -d        GRID_RESOLUTION should be among the available benchs if -bench 1
159              among which : 48x36x19, 48x36x39
160              if wanting to run a bench simulation in addition to compilation
161              default : 48x36x19
162
163    -bench     activating the bench or not (0/1). Default 1
164
165    -testing/unstable
166
167    -name      LOCAL_MODEL_NAME : default = LMDZversion.release
168
169    -netcdf    0, 1 or PATH
170                   0: do not download NetCDF, look for it in standard locations
171               1: download and compile NetCDF
172                   PATH: full path to an existing installed NetCDF library
173
174    -xios      also download and compile the XIOS library
175               (requires the NetCDF4-HDF5 library, also installed by default)
176               (requires to also have -parallel mpi_omp)
177
178    -gprof     to compile with -pg to enable profiling with gprof
179
180    -cosp      to run without our with cospv1 or cospv2 [none/v1/v2]
181
182    -rad RADIATIF can be oldrad, rrtm or ecrad radiatif code
183
184    -nofcm     to compile without fcm
185
186    -SCM        install 1D version automatically
187
188    -debug      compile everything in debug mode
189
190    -opt_makelmdz     to call makelmdz or makelmdz_fcm with additional options
191
192    -physiq    to choose which physics package to use
193
194    -env_file  specify an arch.env file to overwrite the existing one
195
196    -veget surface model to run [NONE/CMIP6/xxxx]
197
198........fin
199              exit ;;
200        "-v") version=$2 ; shift ; shift ;;
201        "-r") svn=$2 ; shift ; shift ;;
202        "-compiler") compiler=$2
203                     case $compiler in
204                         "gfortran"|"ifort"|"pgf90") compiler=$2 ; shift
205                                                     shift ;;
206                         *) echo "Only gfortran , ifort or pgf90 for the " \
207                                 "compiler option"
208                            exit
209                     esac ;;
210        "-d") grid_resolution=$2 ; shift ; shift ;;
211        "-gprof") OPT_GPROF="-pg" ; shift ;;
212        "-unstable"|"-testing") trusting=`echo $1 | cut -c2-`  ; shift ;;
213        "-cosp") cosp=$2
214                 case $cosp in
215                     "none"|"v1"|"v2") cosp=$2 ; shift ; shift ;;
216                     *) echo Only none v1 v2 for cosp option ; exit
217                 esac ;;
218        "-nofcm") compile_with_fcm=0 ; echo This option will be reactivated soon '(promesse du 8dec2022)' ; exit 1 ;  shift ;;
219        "-SCM") SCM=1 ; shift ;;
220        "-opt_makelmdz") OPT_MAKELMDZ="$2" ; shift ; shift ;;
221        "-rrtm") rrtm="$2"
222                 if [ "$2" = "false" ] ; then
223                     rad="oldrad"
224                 else
225                     rad="rrtm"
226                 fi
227                 shift ; shift ;;
228        "-rad") rad=$2
229                case $rad in
230                    "oldrad"|"rrtm"|"ecrad") rad=$2 ; shift ; shift ;;
231                    *) echo Only oldrad rrtm ecrad for rad option ; exit
232                esac ;;
233        "-parallel") parallel=$2
234                     case $parallel in
235                         "none"|"mpi"|"omp"|"mpi_omp") parallel=$2 ; shift
236                                                       shift ;;
237                         *) echo Only none mpi omp mpi_omp for the parallel \
238                                 option
239                            exit
240                     esac ;;
241        "-bench") bench=$2 ; shift ; shift ;;
242        "-debug") optim=-debug ; shift ;;
243        "-name") MODEL=$2 ; shift ; shift ;;
244        "-netcdf") case $2 in
245                       0|1) netcdf=$2 ;;
246                       *) netcdf=`ls -d $2` ; if [ $? != 0 ] ; then echo No directory $2 ; exit 1 ; fi
247                   esac
248                   shift ; shift ;;
249        "-physiq") physiq=$2 ; shift ; shift ;;
250        "-xios") with_xios="y" ; shift ;;
251        "-env_file") env_file=$2 ; shift ; shift ;;
252        "-veget") veget=$2 ; shift ; shift ;;
253        *) ./install_lmdz.sh -h ; exit
254    esac
255done
256
257# Option de compilation du rayonnement : depend de $mysvn ><= r4185,
258# sera donc definie plus bas
259
260#opt_rad=""
261#case $rad in
262#   rrtm) opt_rad="-rad rrtm" ;;
263#   ecrad) opt_rad="-rad ecrad" ;;
264#esac
265
266
267# Option de compilation pour Cosp
268opt_cosp=""
269case cosp in
270    v1) opt_cosp="-cosp true" ;;
271    v2) opt_cosp="-cospv2 true" ;;
272esac
273
274# Check on veget version
275#if [ "$veget" != 'NONE'  -a "$veget" != "CMIP6" -a "$veget" != +([0-9]) ] ; then
276if [ $veget != 'NONE'   -a $veget != "CMIP6" ] ; then
277    re='^[0-9]+$'
278    if ! [[ $veget =~ $re ]] ; then
279        echo 'Valeur de l option veget non valable'
280        exit
281    fi
282fi
283
284#Define veget-related suffix for gcm name
285if [ "$veget" = 'NONE' ] ; then
286    suff_orc=''
287    #For use with tutorial, orchidee_rev is also defined (will be
288    #written in surface_env at the end of the script)
289    orchidee_rev=''
290else
291    suff_orc='_orch'
292fi
293
294
295if [ $parallel = none ] ; then
296    sequential=1; suff_exe='_seq'
297else
298    sequential=0; suff_exe='_para_mem'
299fi
300
301#Chemin pour placer le modele
302if [ "$MODEL" = "" ] ; then MODEL=./LMDZ$version$svn$optim ; fi
303
304
305arch=local
306
307
308if [ $compiler = g95 ] ; then echo g95 is not supported anymore ; exit ; fi
309
310################################################################
311# Specificite des machines
312################################################################
313
314hostname=`hostname`
315if [ "$pclinux" = 1 ] ; then o_ins_make="-t g95" ; else o_ins_make="" ; fi
316
317case ${hostname:0:5} in
318
319    jean-)   compiler="mpiifort" ;
320             par_comp="mpiifort" ;
321             o_ins_make="-t jeanzay" ;
322             make=gmake ;
323             module purge
324             module load intel-compilers/19.0.4 ;
325             #module load intel-mpi/19.0.4 ;
326             #module load intel-mkl/19.0.4 ;
327             module load hdf5/1.10.5-mpi ;
328             module load netcdf/4.7.2-mpi ;
329             module load netcdf-fortran/4.5.2-mpi ;
330             module load subversion/1.9.7 ;
331             module load cmake
332             export NETCDF_LIBDIR=./
333             export NETCDFFORTRAN_INCDIR=./
334             export NETCDFFORTRAN_LIBDIR=./
335             arch=X64_JEANZAY ;;
336
337    cicla|camel)   compiler="gfortran" ;
338                   module purge
339                   module load gnu/10.2.0
340                   module load openmpi/4.0.5
341                   module load hdf5/1.10.7-mpi
342                   module load netcdf-c/4.7.4-mpi
343                   module load netcdf-fortran/4.5.3-mpi
344                   netcdf=/net/nfs/tools/PrgEnv/linux-scientific6-x86_64/gcc-10.2.0/netcdf-fortran-4.5.3-k3drgfqok3lip62hnm3tsyof4cjen5sk
345                   module load svn/1.14.0
346
347                   if [ $parallel != none ] ; then
348                       root_mpi=/net/nfs/tools/meso-sl6/openmpi/4.0.5-gcc-10.2.0
349                       path_mpi=$root_mpi/bin ;
350                       par_comp=${path_mpi}/mpif90 ;
351                       mpirun=${path_mpi}/mpirun ;
352                   fi ;
353                   arch=local  ;
354                   make=make ;
355                   o_ins_make="-t g95" ;;
356
357    *)       if [ $parallel = none -o -f /usr/bin/mpif90 ] ; then
358                 path_mpi=`which mpif90 | sed -e s:/mpif90::` ;
359                 if [ -d /usr/lib64/openmpi ] ; then
360                     root_mpi="/usr/lib64/openmpi"
361                 else
362                     root_mpi="/usr"
363                 fi
364             else
365                 echo "Cannot find mpif90" ;
366                 if [ $parallel = none ] ; then exit ; fi ;
367             fi ;
368             if [ $parallel != none ] ; then
369                 root_mpi=$(which mpif90 | sed -e s:/bin/mpif90::)
370                 path_mpi=$(which mpif90 | sed -e s:/mpif90::)
371                 export LD_LIBRARY_PATH=${root_mpi}/lib:$LD_LIBRARY_PATH
372             fi
373             par_comp=${path_mpi}/mpif90 ;
374             mpirun=${path_mpi}/mpirun ;
375             arch=local  ;
376             make=make ;
377             o_ins_make="-t g95"
378esac
379
380# Flags for parallelism:
381if [ $parallel != none ] ; then
382    # MPI_LD are the flags needed for linking with MPI
383    MPI_LD="-L${root_mpi}/lib -lmpi"
384    if [ "$compiler" = "gfortran" ] ; then
385        # MPI_FLAGS are the flags needed for compilation with MPI
386        MPI_FLAGS="-fcray-pointer"
387        # OMP_FLAGS are the flags needed for compilation with OpenMP
388        OMP_FLAGS="-fopenmp -fcray-pointer"
389        # OMP_LD are the flags needed for linking with OpenMP
390        OMP_LD="-fopenmp"
391    elif [ "$compiler" = "ifort" ] ; then
392        MPI_FLAGS=""
393        OMP_FLAGS="-openmp"
394        OMP_LD="-openmp"
395    else # pgf90
396        MPI_FLAGS=""
397        OMP_FLAGS="-mp"
398        OMP_LD="-mp"
399    fi
400fi
401
402#####################################################################
403# Test for old gfortran compilers
404# If the compiler is too old (older than 4.3.x) we test if the
405# temporary gfortran44 patch is available on the computer in which
406# case the compiler is changed from gfortran to gfortran44
407# Must be aware than parallelism can not be activated in this case
408#####################################################################
409
410if [ "$compiler" = "gfortran" ] ; then
411    gfortran=gfortran
412    gfortranv=`gfortran --version | \
413   head -1 | awk ' { print $NF } ' | awk -F. ' { print $1 * 10 + $2 } '`
414    if [ $gfortranv -le 43 ] ; then
415        echo ERROR : Your gfortran compiler is too old
416        echo 'Please choose a new one (ifort) and change the line'
417        echo compiler=xxx
418        echo in the install_lmdz.sh script and rerun it
419        if [ `which gfortran44 | wc -w` -ne 0 ] ; then
420            gfortran=gfortran44
421        else
422            echo gfotran trop vieux ; exit
423        fi
424    fi
425    compiler=$gfortran
426fi
427#####################################################################
428
429## if also compiling XIOS, parallel must be mpi_omp
430if [ "$with_xios" = "y" -a "$parallel" != "mpi_omp" ] ; then
431    echo "Error, you must set -parallel mpi_omp if you want XIOS"
432    exit
433fi
434
435if [ "$with_xios" = "y" ] ; then
436    opt_makelmdz_xios="-io xios"
437fi
438
439if [ "$cosp" = "v2" -a "$with_xios" = "n" ] ; then
440    echo "Error, Cospv2 cannot run without Xios"
441    exit
442fi
443
444echo '################################################################'
445echo  Choix des options de compilation
446echo '################################################################'
447
448export FC=$compiler
449export F90=$compiler
450export F77=$compiler
451export CPPFLAGS=
452OPTIMNC=$OPTIM
453BASE_LD="$OPT_GPROF"
454OPTPREC="$OPT_GPROF"
455ARFLAGS="rs"
456if [ "`lsb_release -i -s`" = "Ubuntu" ] ; then
457    if [ "`lsb_release -r -s | cut -d. -f1`" -ge 16 ] ; then
458            ARFLAGS="rU"
459    fi
460fi
461
462if [ "$compiler" = "$gfortran" ] ; then
463   OPTIM="-O3 $allow_arg_mismatch"
464   OPTDEB="-g3 -Wall -fbounds-check -ffpe-trap=invalid,zero,overflow -O0 -fstack-protector-all -fbacktrace -finit-real=snan  $allow_arg_mismatch"
465   OPTDEV="-Wall -fbounds-check  $allow_arg_mismatch"
466   fmod='I '
467   OPTPREC="$OPTPREC -cpp -ffree-line-length-0"
468   if [ $real = r8 ] ; then OPTPREC="$OPTPREC -fdefault-real-8 -DNC_DOUBLE" ; fi
469   export F90FLAGS=" -ffree-form $OPTIMNC"
470   export FFLAGS=" $OPTIMNC"
471   export CC=gcc
472   export CXX=g++
473   export fpp_flags="-P -C -traditional -ffreestanding"
474
475elif [ $compiler = mpif90 ] ; then
476    OPTIM='-O3'
477    OPTDEB="-g3 -Wall -fbounds-check -ffpe-trap=invalid,zero,overflow -O0 -fstack-protector-all"
478    OPTDEV="-Wall -fbounds-check"
479    BASE_LD="$BASE_LD -lblas"
480    fmod='I '
481    if [ $real = r8 ] ; then
482        OPTPREC="$OPTPREC -fdefault-real-8 -DNC_DOUBLE -fcray-pointer"
483    fi
484    export F90FLAGS=" -ffree-form $OPTIMNC"
485    export FFLAGS=" $OPTIMNC"
486    export CC=gcc
487    export CXX=g++
488
489elif [ $compiler = pgf90 ] ; then
490    OPTIM='-O2 -Mipa -Munroll -Mnoframe -Mautoinline -Mcache_align'
491    OPTDEB='-g -Mdclchk -Mbounds -Mchkfpstk -Mchkptr -Minform=inform -Mstandard -Ktrap=fp -traceback'
492    OPTDEV='-g -Mbounds -Ktrap=fp -traceback'
493    fmod='module '
494    if [ $real = r8 ] ; then OPTPREC="$OPTPREC -r8 -DNC_DOUBLE" ; fi
495    export CPPFLAGS="-DpgiFortran"
496    export CC=pgcc
497    export CFLAGS="-O2 -Msignextend"
498    export CXX=pgCC
499    export CXXFLAGS="-O2 -Msignextend"
500    export FFLAGS="-O2 $OPTIMNC"
501    export F90FLAGS="-O2 $OPTIMNC"
502    compile_with_fcm=1
503
504elif [[ $compiler = ifort || $compiler = mpiifort ]] ; then
505    OPTIM="-O2 -fp-model strict -ip -align all "
506    OPTDEV="-p -g -O2 -traceback -fp-stack-check -ftrapuv -check"
507    OPTDEB="-g -no-ftz -traceback -ftrapuv -fp-stack-check -check"
508    fmod='module '
509    if [ $real = r8 ] ; then OPTPREC="$OPTPREC -real-size 64 -DNC_DOUBLE" ; fi
510    export CPP="icc -E"
511    export FFLAGS="-O2 -ip -fpic -mcmodel=large"
512    export FCFLAGS="-O2 -ip -fpic -mcmodel=large"
513    export CC=icc
514    export CFLAGS="-O2 -ip -fpic -mcmodel=large"
515    export CXX=icpc
516    export CXXFLAGS="-O2 -ip -fpic -mcmodel=large"
517    export fpp_flags="-P -traditional"
518    # Pourquoi forcer la compilation fcm. Marche mieux sans
519    #compile_with_fcm=1
520else
521    echo unexpected compiler $compiler ; exit
522fi
523
524OPTIMGCM="$OPTIM $OPTPREC"
525
526hostname=`hostname`
527
528##########################################################################
529# If installing on known machines such as Jean-Zay at IDRIS,
530# don't check for available software and don't install netcdf
531if [ ${hostname:0:5} = jean- ] ; then
532    netcdf=0 # no need to recompile netcdf, alreday available
533    check_linux=0
534    pclinux=0
535    ioipsl=0 # no need to recompile ioipsl, already available
536    #netcdf="/smplocal/pub/NetCDF/4.1.3"
537    compiler="mpiifort"
538    fmod='module '
539    if [ $real = r8 ] ; then OPTPREC="$OPTPREC -i4 -r8 -DNC_DOUBLE" ; fi
540    OPTIM="-auto -align all -O2 -fp-model strict -xHost "
541    OPTIMGCM="$OPTIM $OPTPREC"
542fi
543##########################################################################
544
545
546mkdir -p $MODEL
547echo $MODEL
548MODEL=`( cd $MODEL ; pwd )` # to get absolute path, if necessary
549
550
551if [ "$check_linux" = 1 ] ; then
552    echo '################################################################'
553    echo   Check if required software is available
554    echo '################################################################'
555
556    #### Ehouarn: test if the required shell is available
557    #### Maj FH-LF-AS 2021-04 : default=bash ; if bash missing, use ksh
558    use_shell="bash" # default
559    if [ "`which bash`" = "" ] ; then
560        echo "no bash ; we will use ksh"
561        use_shell="ksh"
562        if [ "`which ksh`" = "" ] ; then
563            echo "bash (or ksh) needed!! Install it!"
564            exit
565        fi
566    fi
567
568    for logiciel in wget tar gzip make $compiler gcc cmake m4 c++ ; do
569        if [ "`which $logiciel`" = "" ] ; then
570            echo You must first install $logiciel on your system
571            exit
572        fi
573    done
574
575    if [ $pclinux = 1 ] ; then
576        cd $MODEL
577        cat <<eod > tt.f90
578print*,'coucou'
579end
580eod
581        $compiler tt.f90 -o a.out
582        ./a.out >| tt
583        if [ "`cat tt | sed -e 's/ //g' `" != "coucou" ] ; then
584            echo problem installing with compiler $compiler ; exit ; fi
585        \rm tt a.out tt.f90
586    fi
587fi
588
589###########################################################################
590if [ $getlmdzor = 1 -a ! -d $MODEL/modipsl ] ; then
591###########################################################################
592   echo '##########################################################'
593   echo  Download a slightly modified version of  LMDZ
594   echo '##########################################################'
595   cd $MODEL
596   getlog=`pwd`/get.log
597   echo logfile : $getlog
598   myget src_archives/$trusting/modipsl.$version.tar.gz >> get.log 2>&1
599   echo install_lmdz.sh wget_OK `date`
600   gunzip modipsl.$version.tar.gz >> get.log 2>&1
601   tar xf modipsl.$version.tar >> get.log 2>&1
602   \rm modipsl.$version.tar
603fi
604
605###########################################################################
606if [ $netcdf = 1 ] ; then
607###########################################################################
608    cd $MODEL
609    netcdflog=`pwd`/netcdf.log
610    echo '----------------------------------------------------------'
611    echo Compiling the Netcdf library
612    echo '----------------------------------------------------------'
613    echo log file : $netcdflog
614
615    case $compiler in
616      gfortran) opt1="-compiler gnu" ; opt2="-CC gcc -FC gfortran -CXX g++" ;;
617      ifort)  opt1="-compiler intel" ; opt2="-CC icc -FC ifort -CXX icpc" ;;
618      pgf90)  opt1="-compiler pgf90" ; opt2="-CC pgcc -FC pgf90 -CXX pgCC" ;;
619      *)      echo "unexpected compiler $compiler" for netcdf ; exit 1
620    esac
621
622    case $with_xios in
623        n) script_install_netcdf=install_netcdf4_hdf5_seq.bash
624           ncdfdir=$MODEL/netcdf4_hdf5_seq
625           opt_=$opt1 ;;
626        y) script_install_netcdf=install_netcdf4_hdf5.bash
627           ncdfdir=$MODEL/netcdf4_hdf5
628           opt_="$opt2 -MPI $root_mpi" ;;
629        *) echo with_xios=$with_xios, should be n or y ; exit 1
630    esac
631         
632    if [[ ! -d $ncdfdir ]] ; then
633        myget script_install/$script_install_netcdf >> $netcdflog 2>&1
634        chmod u=rwx $script_install_netcdf
635        ./$script_install_netcdf -prefix $ncdfdir $opt_ >> $netcdflog 2>&1
636    fi
637
638    #----------------------------------------------------------------------------
639    # LF rajout d'une verrue, pour une raison non encore expliquee,
640    # la librairie est parfois rangée dans lib64 et non dans lib
641    # par certains compilateurs
642    if [ ! -e lib -a -d lib64 ] ; then ln -s lib64 lib; fi
643    #----------------------------------------------------------------------------
644
645    echo install_lmdz.sh netcdf_OK `date`
646
647elif [ $netcdf = 0 ] ; then
648    ncdfdir=/usr
649else
650    ncdfdir=$netcdf
651fi
652
653cat >test_netcdf90.f90 <<EOF
654use netcdf
655print *, "NetCDF library version: ", nf90_inq_libvers()
656end
657EOF
658
659$compiler -I$ncdfdir/include test_netcdf90.f90 -L$ncdfdir/lib -lnetcdff \
660          -lnetcdf -Wl,-rpath=$ncdfdir/lib && ./a.out
661   
662if (($? == 0))
663then
664    rm test_netcdf90.f90 a.out
665else
666    echo "Failed test program using NetCDF-Fortran."
667    echo "You can:"
668    echo "- check that you have NetCDF-Fortran installed in your system"
669    echo "- or specify an installation directory with option -netcdf of" \
670         "install_lmdz.sh"
671    echo "- or download and compile NetCDF-Fortran with option -netcdf 1 of" \
672         "install_lmdz.sh"
673    exit 1
674fi
675
676#=========================================================================
677if [[ ! -f $MODEL/modipsl/lib/libioipsl.a ]]
678then
679    if [ $ioipsl = 1 ] ; then
680        #=====================================================================
681        echo OK ioipsl=$ioipsl
682        echo '##########################################################'
683        echo 'Installing MODIPSL, the installation package manager for the '
684        echo 'IPSL models and tools'
685        echo '##########################################################'
686        echo `date`
687
688        cd $MODEL/modipsl
689        \rm -rf lib/*
690        cd util
691        cp AA_make.gdef AA_make.orig
692        F_C="$compiler -c "
693        if [ "$compiler" = "$gfortran" -o "$compiler" = "mpif90" ]
694        then
695            F_C="$compiler -c -cpp "
696        fi
697        if [ "$compiler" = "pgf90" ] ; then F_C="$compiler -c -Mpreprocess" ; fi
698        sed -e 's/^\#.*.g95.*.\#.*.$/\#/' AA_make.gdef > tmp
699        sed -e "s:F_L = g95:F_L = $compiler:" \
700            -e "s:F_C = g95 -c -cpp:F_C = $F_C": \
701            -e 's/g95.*.w_w.*.(F_D)/g95      w_w = '"$OPTIMGCM"'/' \
702            -e 's:g95.*.NCDF_INC.*.$:g95      NCDF_INC= '"$ncdfdir"'/include:' \
703            -e 's:g95.*.NCDF_LIB.*.$:g95      NCDF_LIB= -L'"$ncdfdir"'/lib -lnetcdff -lnetcdf:' \
704            -e 's:g95      L_O =:g95      L_O = -Wl,-rpath='"$ncdfdir"'/lib:' \
705            -e "s:-fmod=:-$fmod:" -e 's/-fno-second-underscore//' \
706            -e 's:#-Q- g95      M_K = gmake:#-Q- g95      M_K = make:' \
707            tmp >| AA_make.gdef
708
709        if [ $pcmac == 1 ]
710        then
711            cp AA_make.gdef tmp
712            sed -e 's/rpath=/rpath,/g' tmp > AA_make.gdef
713        fi
714
715
716        # We use lines for g95 even for the other compilers to run ins_make
717        if [ "$use_shell" = "ksh" ] ; then
718            ./ins_make $o_ins_make
719        else # bash
720            sed -e s:/bin/ksh:/bin/bash:g ins_make > ins_make.bash
721            if [ "`grep jeanzay AA_make.gdef`" = "" ] ; then
722                # Bidouille pour compiler sur ada des vieux modipsl.tar
723                echo 'Warning jean-zay not in AA_make.gdef'
724                echo 'Think about updating'
725                exit 1
726            fi
727
728            chmod u=rwx ins_make.bash
729            ./ins_make.bash $o_ins_make
730        fi # of if [ "$use_shell" = "ksh" ]
731
732        echo install_lmdz.sh MODIPSL_OK `date`
733
734        cd $MODEL/modipsl/modeles/IOIPSL/src
735        ioipsllog=`pwd`/ioipsl.log
736        echo '##########################################################'
737        echo 'Compiling IOIPSL, the interface library with Netcdf'
738        echo '##########################################################'
739        echo `date`
740        echo log file : $ioipsllog
741
742        if [ "$use_shell" = "bash" ] ; then
743            cp Makefile Makefile.ksh
744            sed -e s:/bin/ksh:/bin/bash:g Makefile.ksh > Makefile
745        fi
746        ### if [ "$pclinux" = 1 ] ; then
747        # Build IOIPSL modules and library
748        $make clean
749        $make > $ioipsllog 2>&1
750        if [ "$compiler" = "$gfortran" -o "$compiler" = "mpif90" ] ; then
751            # copy module files to lib
752            cp -f *.mod ../../../lib
753        fi
754        # Build IOIPSL tools (ie: "rebuild", if present)
755        if [ -f $MODEL/modipsl/modeles/IOIPSL/tools/rebuild ] ; then 
756            cd $MODEL/modipsl/modeles/IOIPSL/tools
757            # adapt Makefile & rebuild script if in bash
758            if [ "$use_shell" = "bash" ] ; then
759                cp Makefile Makefile.ksh
760                sed -e s:/bin/ksh:/bin/bash:g Makefile.ksh > Makefile
761                cp rebuild rebuild.ksh
762                sed -e 's:/bin/ksh:/bin/bash:g' \
763                    -e 's:print -u2:echo:g' \
764                    -e 's:print:echo:g' rebuild.ksh > rebuild
765            fi
766            $make clean
767            $make > $ioipsllog 2>&1
768        fi
769        ### fi # of if [ "$pclinux" = 1 ] which is commented out
770
771    else # of if [ $ioipsl = 1 ]
772        if [ ${hostname:0:5} = jean- ] ; then
773            cd $MODEL/modipsl
774            cd util
775            if [ "`grep jeanzay AA_make.gdef`" = "" ] ; then
776                echo 'Warning jean-zay not in AA_make.gdef'
777                echo 'Think about updating'
778                exit 1
779            fi
780            ./ins_make $o_ins_make
781            # Compile IOIPSL on jean-zay
782            cd $MODEL/modipsl/modeles/IOIPSL/src
783            gmake > ioipsl.log
784            # For IOIPSLv_2_2_2, "rebuild" files are in IOIPSL/tools, so "gmake" in IOIPSL/tools is enough
785            # For IOIPSLv_2_2_5, "rebuild" files are in a separate IOIPSL/rebuild folder , while "tools" only contains "FCM"
786            if [ -f $MODEL/modipsl/modeles/IOIPSL/tools/Makefile ] ; then
787              cd $MODEL/modipsl/modeles/IOIPSL/tools
788              gmake > ioipsl.log
789            fi
790            if [ -d $MODEL/modipsl/modeles/IOIPSL/rebuild ] ; then
791              cd $MODEL/modipsl/modeles/IOIPSL/rebuild
792              gmake > ioipsl.log
793            fi
794
795        fi
796        echo install_lmdz.sh ioipsl_OK `date`
797    fi # of if [ $ioipsl = 1 ]
798fi # of if [[ ! -f $MODEL/modipsl/lib/libioipsl.a ]]
799
800#=========================================================================
801if [ "$with_xios" = "y" ] ; then
802    echo '##########################################################'
803    echo 'Compiling XIOS'
804    echo '##########################################################'
805    cd $MODEL/modipsl/modeles
806    xioslog=`pwd`/xios.log
807    #wget http://www.lmd.jussieu.fr/~lmdz/Distrib/install_xios.bash
808    myget script_install/install_xios.bash
809    chmod u=rwx install_xios.bash
810    if [ ${hostname:0:5} = jean- ] ; then
811        svn co http://forge.ipsl.jussieu.fr/ioserver/svn/XIOS/branchs/xios-2.5 \
812            XIOS
813        cd XIOS/arch
814        svn update
815        cd ..
816        echo "Compiling XIOS, start" `date` \
817             "(it takes about 20 min on Jean-Zay)"
818        echo "log file: $xioslog"
819        ./make_xios --prod --arch $arch --job 4 > xios.log 2>&1
820    else
821        ./install_xios.bash -prefix $MODEL/modipsl/modeles \
822                            -netcdf ${ncdfdir} -hdf5 ${ncdfdir} \
823                            -MPI $root_mpi -arch $arch > xios.log 2>&1
824    fi # of case Jean-Zay
825    if [ -f XIOS/lib/libxios.a ] ; then
826        echo "XIOS library successfully generated"
827        echo install_lmdz.sh XIOS_OK `date`
828    fi
829fi
830
831#============================================================================
832veget_version=false
833if [ "$veget" != 'NONE' ] ; then
834    cd $MODEL/modipsl/modeles/ORCHIDEE
835    set +e ; svn upgrade ; set -e
836    if [ "$veget" = "CMIP6" ] ; then
837        veget_version=orchidee2.0
838        orchidee_rev=6592
839    else # specific orchidee revision newer than CMIP6, on 2_1 or 2_2 branches
840        veget_version=orchidee2.1
841        orchidee_rev=$veget
842        if [ $veget -lt 4465 ] ; then
843            echo 'Stopping, ORCHIDEE version too old, script needs work on ' \
844                 'the CPP flags to pass to makelmdz'
845            exit 1
846        fi
847        set +e
848        # which branch is my version on?
849        orcbranch=`svn log -v -q svn://forge.ipsl.jussieu.fr/orchidee/ -r $veget |grep ORCHIDEE |head -1| sed -e 's:ORCHIDEE/.*$:ORCHIDEE:' | awk '{print $2}'`
850        # switch to that branch
851        echo IF YOU INSTALL ORCHIDEE THE VERY FIRST TIME, ASK for PASSWORD at \
852             orchidee-help@listes.ipsl.fr
853        svn switch -r $veget --accept theirs-full \
854            svn://forge.ipsl.jussieu.fr/orchidee/$orcbranch
855        svn log -r $veget | grep  $veget
856        if [  $? -gt 0 ] ; then
857            echo 'Cannot update ORCHIDEE as not on the right branch for ' \
858                 'ORCHIDEE'
859            exit
860        fi
861        set -e
862        set +e ; svn update -r $veget ; set -e
863    fi
864    # Correctif suite debug Jean-Zay
865    sed -i -e 's/9010  FORMAT(A52,F17.14)/9010  FORMAT(A52,F20.14)/' \
866        src_stomate/stomate.f90
867    opt_orc="-prod" ; if [ "$optim" = "-debug" ] ; then opt_orc="-debug" ; fi
868
869    orchideelog=`pwd`/orchidee.log
870    echo '########################################################'
871    echo 'Compiling ORCHIDEE, the continental surface model '
872    echo '########################################################'
873    echo Start of the first compilation of orchidee, in sequential mode: `date`
874    echo log file : $orchideelog
875
876    export ORCHPATH=`pwd`
877    xios_orchid="-noxios"
878    if [ "$with_xios" = "y" ] ; then
879        xios_orchid="-xios"
880    fi
881    if [ -d tools ] ; then
882        ###################################################################
883        # Pour les experts qui voudraient changer de version d'orchidee.
884        # Attention : necessite d'avoir le password pour orchidee
885
886        # Correctif suite debug Jean-Zay
887        if [ -f src_global/time.f90 ] ; then
888            sed -i -e 's/CALL tlen2itau/\!CALL tlen2itau/' src_global/time.f90
889        fi
890        ###################################################################
891        if [ "$veget_version" == "false" ] ; then
892            veget_version=orchidee2.0
893        fi
894        cd arch
895        sed -e s:"%COMPILER        .*.$":"%COMPILER            $compiler":1 \
896            -e s:"%LINK            .*.$":"%LINK                $compiler":1 \
897            -e s:"%FPP_FLAGS       .*.$":"%FPP_FLAGS           $fpp_flags":1 \
898            -e s:"%PROD_FFLAGS     .*.$":"%PROD_FFLAGS         $OPTIM":1 \
899            -e s:"%DEV_FFLAGS      .*.$":"%DEV_FFLAGS          $OPTDEV":1 \
900            -e s:"%DEBUG_FFLAGS    .*.$":"%DEBUG_FFLAGS        $OPTDEB":1 \
901            -e s:"%BASE_FFLAGS     .*.$":"%BASE_FFLAGS         $OPTPREC":1 \
902            -e s:"%BASE_LD         .*.$":"%BASE_LD             $BASE_LD":1 \
903            -e s:"%ARFLAGS         .*.$":"%ARFLAGS             $ARFLAGS":1 \
904            arch-gfortran.fcm > arch-local.fcm
905        echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib -lnetcdff -lnetcdf\"" \
906             > arch-local.path
907        echo "NETCDF_INCDIR=${ncdfdir}/include" >> arch-local.path
908        echo "IOIPSL_INCDIR=$ORCHPATH/../../lib" >> arch-local.path
909        echo "IOIPSL_LIBDIR=$ORCHPATH/../../lib" >> arch-local.path
910        echo 'XIOS_INCDIR=${ORCHDIR}/../XIOS/inc' >> arch-local.path
911        echo 'XIOS_LIBDIR="${ORCHDIR}/../XIOS/lib -lxios"' >> arch-local.path
912        cd ../
913
914        echo ./makeorchidee_fcm -j $xios_orchid $opt_orc -parallel none \
915             -arch $arch
916        ./makeorchidee_fcm -j 8 $xios_orchid $opt_orc -parallel none \
917                           -arch $arch > $orchideelog 2>&1
918        pwd
919    else # of "if [ -d tools ]"
920        if [ -d src_parallel ] ; then
921            liste_src="parallel parameters global stomate sechiba driver"
922            if [ "$veget_version" == "false" ] ; then
923                veget_version=orchidee2.0
924            fi
925        fi
926        for d in $liste_src ; do
927            src_d=src_$d
928            echo src_d $src_d
929            echo ls ; ls
930            if [ ! -d $src_d ] ; then
931                echo Problem orchidee : no $src_d ; exit
932            fi
933            cd $src_d ; \rm -f *.mod make ; $make clean
934            $make > $orchideelog 2>&1
935            if [ "$compiler" = "$gfortran" -o "$compiler" = "mpif90" ] ; then
936                cp -f *.mod ../../../lib
937            fi
938            cd ..
939        done
940    fi # of "if [ -d tools ]"
941    echo install_lmdz.sh orchidee_compil_seq_OK `date`
942fi # of if [ "$veget" != 'NONE' ]
943
944
945#============================================================================
946# Ehouarn: the directory name LMDZ* depends on version/tar file...
947if [ -d $MODEL/modipsl/modeles/LMD* ] ; then
948    echo '###############################################################'
949    echo 'Preparing LMDZ compilation : arch file, svn switch if needed...'
950    echo '###############################################################'
951    cd $MODEL/modipsl/modeles/LMD*
952    LMDZPATH=`pwd`
953else
954    echo "ERROR: No LMD* directory !!!"
955    exit
956fi
957
958###########################################################
959# For those who want to use fcm to compile via :
960#  makelmdz_fcm -arch local .....
961############################################################
962
963
964
965cd $MODEL/modipsl/modeles/LMDZ*
966lmdzlog=`pwd`/lmdz.log
967
968##################################################################
969# Possibly update LMDZ if a specific svn release is requested
970##################################################################
971
972set +e ; svn upgrade ; set -e
973
974if [ "$svn" = "last" ] ; then svnopt="" ; else svnopt="-r $svn" ; fi
975if [ "$svn" != "" ] ; then
976    set +e ; svn info | grep -q 'http:'
977    if [ $? = 0 ] ; then
978        svn switch --relocate http://svn.lmd.jussieu.fr/LMDZ \
979            https://svn.lmd.jussieu.fr/LMDZ
980    fi
981    svn update $svnopt
982    set -e
983fi
984
985#---------------------------------------------------------------------
986# Retrieve the final svn release number, and adjust compilation
987# options accordingly
988# If svn not available, will use the svn writen in $MODEL/Readm*md
989# For old version it assumes that it is before 4185 (the version
990# for which the test was introduced
991#---------------------------------------------------------------------
992
993set +e ; mysvn=`svnversion . | egrep -o "[0-9]+" 2>/dev/null` ; set -e
994if [ "$mysvn" = "" ] ; then mysvn=`grep 'Revision: [0-9]' $MODEL/Read*.md | awk ' { print $2 } ' 2>/dev/null` ; fi
995if [ "$mysvn" = "" ] ; then mysvn=4190 ; fi
996
997if [[ "$pclinux" = "1" && ! -f arch/arch-local.path ]] ; then
998
999    # create local 'arch' files (if on Linux PC):
1000    cd arch
1001    # arch-local.path file
1002    # test for version as arch.pth file changed format with rev 4426
1003    if [ "$mysvn" -gt 4425 ] ; then
1004      echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib \"" > arch-local.path
1005      echo "NETCDF_LIB=\"-lnetcdff -lnetcdf\"" >> arch-local.path
1006      echo "NETCDF_INCDIR=-I${ncdfdir}/include" >> arch-local.path
1007      echo 'NETCDF95_INCDIR=-I$LMDGCM/../../include' >> arch-local.path
1008      echo 'NETCDF95_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
1009      echo 'NETCDF95_LIB=-lnetcdf95' >> arch-local.path
1010      echo 'IOIPSL_INCDIR=-I$LMDGCM/../../lib' >> arch-local.path
1011      echo 'IOIPSL_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
1012      echo 'IOIPSL_LIB=-lioipsl' >> arch-local.path
1013      echo 'XIOS_INCDIR=-I$LMDGCM/../XIOS/inc' >> arch-local.path
1014      echo 'XIOS_LIBDIR=-L$LMDGCM/../XIOS/lib' >> arch-local.path
1015      echo "XIOS_LIB=\"-lxios -lstdc++\"" >> arch-local.path
1016      echo 'ORCH_INCDIR=-I$LMDGCM/../../lib' >> arch-local.path
1017      echo 'ORCH_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
1018    else
1019      echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib -lnetcdff -lnetcdf\"" \
1020         > arch-local.path
1021      echo "NETCDF_INCDIR=-I${ncdfdir}/include" >> arch-local.path
1022      echo 'NETCDF95_INCDIR=$LMDGCM/../../include' >> arch-local.path
1023      echo 'NETCDF95_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
1024      echo 'IOIPSL_INCDIR=$LMDGCM/../../lib' >> arch-local.path
1025      echo 'IOIPSL_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
1026      echo 'XIOS_INCDIR=$LMDGCM/../XIOS/inc' >> arch-local.path
1027      echo 'XIOS_LIBDIR=$LMDGCM/../XIOS/lib' >> arch-local.path
1028      echo 'ORCH_INCDIR=$LMDGCM/../../lib' >> arch-local.path
1029      echo 'ORCH_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
1030    fi 
1031
1032    if [ $pcmac == 1 ] ; then
1033        BASE_LD="$BASE_LD -Wl,-rpath,${ncdfdir}/lib"
1034    else
1035        BASE_LD="$BASE_LD -Wl,-rpath=${ncdfdir}/lib"
1036    fi
1037    # Arch-local.fcm file (adapted from arch-linux-32bit.fcm)
1038
1039    if [ $real = r8 ] ; then FPP_DEF=NC_DOUBLE ; else FPP_DEF="" ; fi
1040    sed -e s:"%COMPILER        .*.$":"%COMPILER            $compiler":1 \
1041        -e s:"%LINK            .*.$":"%LINK                $compiler":1 \
1042        -e s:"%PROD_FFLAGS     .*.$":"%PROD_FFLAGS         $OPTIM":1 \
1043        -e s:"%DEV_FFLAGS      .*.$":"%DEV_FFLAGS          $OPTDEV":1 \
1044        -e s:"%DEBUG_FFLAGS    .*.$":"%DEBUG_FFLAGS        $OPTDEB":1 \
1045        -e s:"%BASE_FFLAGS     .*.$":"%BASE_FFLAGS         $OPTPREC":1 \
1046        -e s:"%FPP_DEF         .*.$":"%FPP_DEF             $FPP_DEF":1 \
1047        -e s:"%BASE_LD         .*.$":"%BASE_LD             $BASE_LD":1 \
1048        -e s:"%ARFLAGS         .*.$":"%ARFLAGS             $ARFLAGS":1 \
1049        arch-linux-32bit.fcm > arch-local.fcm
1050
1051    cd ..
1052    ### Adapt "bld.cfg" (add the shell):
1053    #whereisthatshell=$(which ${use_shell})
1054    #echo "bld::tool::SHELL   $whereisthatshell" >> bld.cfg
1055
1056fi # of if [ "$pclinux" = 1 ]
1057#---------------------------------------------------------------------
1058# Option de compilation du rayonnement : depend de $mysvn ><= r4185
1059#---------------------------------------------------------------------
1060opt_rad=""
1061
1062case $rad in
1063    oldrad) iflag_rrtm=0 ; NSW=2 ; opt_rad="" ;;
1064    rrtm)   iflag_rrtm=1 ; NSW=6
1065            if [ $mysvn -le 4185 ] ; then
1066                opt_rad="-rrtm true"
1067            else
1068                opt_rad="-rad rrtm"
1069            fi ;;
1070    ecrad)  iflag_rrtm=2 ; NSW=6 ; opt_rad="-rad ecrad" ;;
1071    *) echo Only oldrad rrtm ecrad for rad option ; exit
1072esac
1073
1074if [ $mysvn -le 4185 -a $rad = "ecrad" ] ; then
1075    echo "ecrad only available for LMDZ rev starting with 4186 " ; exit
1076fi
1077
1078##################################################################
1079
1080
1081if [[ ! -f libf/misc/netcdf95.F90 &&  ! -d $MODEL/NetCDF95-0.2 ]]
1082then
1083    cd $MODEL
1084    myget src_archives/netcdf/NetCDF95-0.2.tar.gz
1085    tar -xf NetCDF95-0.2.tar.gz
1086    rm NetCDF95-0.2.tar.gz
1087    cd NetCDF95-0.2
1088    mkdir build
1089    cd build
1090    cmake .. -DCMAKE_BUILD_TYPE=Release -DCMAKE_PREFIX_PATH=$ncdfdir \
1091          -DCMAKE_INSTALL_PREFIX=$MODEL/modipsl
1092    make install
1093    cd $MODEL/modipsl/modeles/LMDZ*
1094fi
1095
1096echo '##################################################################'
1097echo "Preparing script compile.sh for LMDZ compilation"
1098echo "It will only be run automatically if bench=1/tuto"
1099echo Here bench=$bench
1100echo '##################################################################'
1101
1102if [ "$env_file" != "" ] ; then
1103    mv arch/arch-${arch}.env arch/arch-${arch}.orig
1104    \cp -f $env_file arch/arch-${arch}.env
1105fi
1106
1107if [ $compile_with_fcm = 1 ] ; then
1108    makelmdz="makelmdz_fcm $optim -arch $arch -j 8 "
1109else
1110    makelmdz="makelmdz $optim -arch $arch"
1111fi
1112
1113# sequential compilation
1114if [ "$sequential" = 1 ] ; then
1115    echo Sequential compilation command, saved in compile.sh:
1116    echo "./$makelmdz $optim $OPT_MAKELMDZ $optim $opt_rad $opt_cosp " \
1117         "-d ${grid_resolution} -v $veget_version gcm "
1118    echo "./$makelmdz $optim $OPT_MAKELMDZ $optim $opt_rad $opt_cosp " \
1119         "-d ${grid_resolution} -v $veget_version gcm " > compile.sh
1120    chmod +x ./compile.sh
1121    if [ $bench = 1 ] ; then
1122        echo install_lmdz.sh start_lmdz_seq_compilation `date`
1123        echo log file: $lmdzlog
1124        ./compile.sh > $lmdzlog 2>&1
1125        echo install_lmdz.sh end_lmdz_seq_compilation `date`
1126    fi
1127fi # fin sequential
1128
1129# compiling in parallel mode
1130if [ $parallel != "none" ] ; then
1131    echo '##########################################################'
1132    echo ' Parallel compile '
1133    echo '##########################################################'
1134    echo "(after saving the sequential libs and binaries)"
1135    cd $MODEL/modipsl
1136    tar cf sequential.tar bin/ lib/
1137    #
1138    # Orchidee
1139    #
1140    cd $ORCHPATH
1141    if [ -d src_parallel -a $veget != 'NONE' ] ; then
1142        cd arch
1143        sed  \
1144            -e s:"%COMPILER.*.$":"%COMPILER            $par_comp":1 \
1145            -e s:"%LINK.*.$":"%LINK                $par_comp":1 \
1146            -e s:"%MPI_FFLAG.*.$":"%MPI_FFLAGS          $MPI_FLAGS":1 \
1147            -e s:"%OMP_FFLAG.*.$":"%OMP_FFLAGS          $OMP_FLAGS":1 \
1148            -e s:"%MPI_LD.*.$":"%MPI_LD              $MPI_LD":1 \
1149            -e s:"%OMP_LD.*.$":"%OMP_LD              $OMP_LD":1 \
1150            arch-local.fcm > tmp.fcm
1151
1152        mv tmp.fcm arch-local.fcm
1153        cd ../
1154        echo Compiling ORCHIDEE in parallel mode `date`
1155        echo logfile $orchideelog
1156        echo "NOTE : to recompile it when necessary, use ./compile_orc.sh " \
1157             "in modipsl/modeles/ORCHIDEE"
1158        echo ./makeorchidee_fcm -j 8 -clean $xios_orchid $opt_orc \
1159             -parallel $parallel -arch $arch > compile_orc.sh
1160        echo ./makeorchidee_fcm -j 8 $xios_orchid $opt_orc \
1161             -parallel $parallel -arch $arch >> compile_orc.sh
1162        echo echo Now you must also recompile LMDZ, by running ./compile.sh \
1163             in modeles/LMDZ >> compile_orc.sh
1164        chmod u+x compile_orc.sh
1165        ./makeorchidee_fcm -j 8 -clean $xios_orchid $opt_orc \
1166                           -parallel $parallel -arch $arch > $orchideelog 2>&1
1167        ./makeorchidee_fcm -j 8 $xios_orchid $opt_orc -parallel $parallel \
1168                           -arch $arch >> $orchideelog 2>&1
1169        echo End of ORCHIDEE compilation in parallel mode `date`
1170    elif [ $veget != 'NONE' ] ; then
1171        echo '##########################################################'
1172        echo ' Orchidee version too old                                 '
1173        echo ' Please update to new version                             '
1174        echo '##########################################################'
1175        exit
1176    fi # of [ -d src_parallel -a $veget != 'NONE' ]
1177
1178    # LMDZ
1179    cd $LMDZPATH
1180    if [ $arch = local ] ; then
1181        cd arch
1182        sed -e s:"%COMPILER.*.$":"%COMPILER            $par_comp":1 \
1183            -e s:"%LINK.*.$":"%LINK                $par_comp":1 \
1184            -e s:"%MPI_FFLAG.*.$":"%MPI_FFLAGS          $MPI_FLAGS":1 \
1185            -e s:"%OMP_FFLAG.*.$":"%OMP_FFLAGS          $OMP_FLAGS":1 \
1186            -e s:"%ARFLAGS.*.$":"%ARFLAGS          $ARFLAGS":1 \
1187            -e s@"%BASE_LD.*.$"@"%BASE_LD             -Wl,-rpath=${root_mpi}/lib:${ncdfdir}/lib"@1 \
1188            -e s:"%MPI_LD.*.$":"%MPI_LD              $MPI_LD":1 \
1189            -e s:"%OMP_LD.*.$":"%OMP_LD              $OMP_LD":1 \
1190            arch-local.fcm > tmp.fcm
1191        mv tmp.fcm arch-local.fcm
1192        cd ../
1193    fi
1194    rm -f compile.sh
1195    echo resol=${grid_resolution} >> compile.sh
1196    if [ ${hostname:0:5} = jean- -a "$cosp" = "v2" ] ; then
1197
1198        echo LMDZ compilation command in parallel mode, saved in compile.sh, \
1199             is :
1200        echo "(ATTENTION le probleme de cospv2 sur jean-zay en mode prod " \
1201             "n est pas corrige ! )"
1202        # ATTENTION le probleme de cospv2 sur jean-zay en mode prod n
1203        # est pas corrige
1204        echo ./$makelmdz -dev $optim $OPT_MAKELMDZ $opt_rad $opt_cosp \
1205             $opt_makelmdz_xios -d \$resol -v $veget_version -mem \
1206             -parallel $parallel gcm >> compile.sh
1207        echo ./$makelmdz -dev $optim $OPT_MAKELMDZ $opt_rad $opt_cosp \
1208             $opt_makelmdz_xios -d \$resol -v $veget_version -mem \
1209             -parallel $parallel gcm
1210    else
1211        echo ./$makelmdz $optim $OPT_MAKELMDZ $opt_rad $opt_cosp \
1212             $opt_makelmdz_xios -d \$resol -v $veget_version -mem \
1213             -parallel $parallel gcm >> compile.sh
1214        echo ./$makelmdz $optim $OPT_MAKELMDZ $opt_rad $opt_cosp \
1215             $opt_makelmdz_xios -d \$resol -v $veget_version -mem \
1216             -parallel $parallel gcm
1217    fi
1218    chmod +x ./compile.sh
1219
1220    if [ $bench = 1 ] ; then
1221        echo Compiling LMDZ in parallel mode `date`,  LMDZ log file: $lmdzlog
1222        ./compile.sh > $lmdzlog 2>&1
1223    fi
1224
1225fi # of if [ $parallel != "none" ]
1226
1227
1228##################################################################
1229# Verification du succes de la compilation
1230##################################################################
1231
1232# Recherche de l'executable dont le nom a change au fil du temps ...
1233# suffix contains radiative option starting with revision 4186
1234if [ $mysvn -ge 4186 ] ; then suff_exe=_${rad}${suff_exe} ; fi
1235gcm=""
1236
1237for exe in gcm.e bin/gcm_${grid_resolution}_phylmd${suff_exe}${suff_orc}.e
1238do
1239    if [ -f $exe ] ; then gcm=$exe ; fi
1240done
1241
1242if [ "$gcm" = "" ] ; then
1243    if [ $bench = 1 ] ; then
1244        echo 'Compilation failed !! Cannot run the benchmark;'
1245        exit
1246    else
1247        echo 'Compilation not done (only done when bench=1)'
1248    fi
1249else
1250    echo '##########################################################'
1251    echo 'Compilation successfull !! ' `date`
1252    echo '##########################################################'
1253    echo The executable is $gcm
1254fi
1255
1256##################################################################
1257# Below, we run a benchmark if bench=1 or tuto
1258##################################################################
1259
1260if [ $bench = tuto ] ; then
1261    myget Training/tutorial.tar ; tar xf tutorial.tar ; cd TUTORIAL
1262    ./init.sh
1263
1264elif [[ $bench = 1 && ! -d BENCH${grid_resolution} ]] ; then
1265    # TOUTE CETTE SECTION DEVRAIT DISPARAITRE POUR UNE COMMANDE
1266    # OU DES BENCHS PAR MOTS CLES COMME tuto
1267
1268    echo '##########################################################'
1269    echo ' Running a test run '
1270    echo '##########################################################'
1271
1272    \rm -rf BENCH${grid_resolution}
1273    bench=bench_lmdz_${grid_resolution}
1274    echo install_lmdz.sh before bench download  `date`
1275    #wget http://www.lmd.jussieu.fr/~lmdz/Distrib/$bench.tar.gz
1276    myget 3DBenchs/$bench.tar.gz
1277    echo install_lmdz.sh after bench download  `date`
1278    tar xf $bench.tar.gz
1279
1280    if [ "$cosp" = "v1" -o "$cosp" = "v2" ] ; then
1281        cd BENCH${grid_resolution}
1282        # copier les fichiers namelist input et output our COSP
1283        cp ../DefLists/cosp*_input_nl.txt .
1284        cp ../DefLists/cosp*_output_nl.txt .
1285        # Activer la cles ok_cosp pour tourner avec COSP
1286        sed -e 's@ok_cosp=n@ok_cosp=y@' config.def > tmp
1287        \mv -f tmp config.def
1288        cd ..
1289    fi
1290
1291    if [ -n "$physiq" ]; then
1292        cd BENCH${grid_resolution}
1293        if [ -f physiq.def_${physiq} ]; then
1294            cp physiq.def_${physiq} physiq.def
1295            echo using physiq.def_${physiq}
1296        else
1297            echo using standard physiq.def
1298        fi
1299        cd ..
1300    else
1301        echo using standard physiq.def
1302    fi
1303
1304    if [ "$with_xios" = "y" ] ; then
1305        cd BENCH${grid_resolution}
1306        cp ../DefLists/iodef.xml .
1307        cp ../DefLists/context_lmdz.xml .
1308        cp ../DefLists/field_def_lmdz.xml .
1309        # A raffiner par la suite
1310        echo A FAIRE : Copier les *xml en fonction de l option cosp
1311        cp ../DefLists/field_def_cosp*.xml .
1312        cp ../DefLists/file_def_hist*xml .
1313        # adapt iodef.xml to use attached mode
1314        sed -e 's@"using_server" type="bool">true@"using_server" type="bool">false@' \
1315            iodef.xml > tmp
1316        \mv -f tmp iodef.xml
1317
1318        # and convert all the enabled="_AUTO_" (for libIGCM) to enabled=.FALSE.
1319        # except for histday
1320        for histfile in file_def_hist*xml
1321        do
1322            if [ "$histfile" = "file_def_histday_lmdz.xml" ] ; then
1323                sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".TRUE."@' \
1324                    $histfile > tmp
1325                \mv -f tmp $histfile
1326                sed -e 's@output_level="_AUTO_"@output_level="5"@' $histfile \
1327                    > tmp
1328                \mv -f tmp $histfile
1329                sed -e 's@compression_level="2"@compression_level="0"@' \
1330                    $histfile > tmp
1331                \mv -f tmp $histfile
1332            else
1333                sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
1334                    $histfile > tmp
1335                \mv -f tmp $histfile
1336            fi
1337        done
1338        # and add option "ok_all_xml=y" in config.def
1339        echo "### XIOS outputs" >> config.def
1340        echo 'ok_all_xml=.true.' >> config.def
1341
1342        #activer les sorties pour Cosp
1343        if [ "$cosp" = "v1" ] ; then
1344            histfile=file_def_histdayCOSP_lmdz.xml
1345            sed -e 's@enabled=".FALSE."@enabled=".TRUE."@' $histfile > tmp
1346            \mv -f tmp $histfile
1347            sed -e 's@output_level="_AUTO_"@output_level="5"@' $histfile > tmp
1348            \mv -f tmp $histfile
1349            sed -e 's@compression_level="2"@compression_level="0"@' \
1350                $histfile > tmp
1351            \mv -f tmp $histfile
1352        fi
1353        if [ "$cosp" = "v2" ] ; then
1354            histfile=file_def_histdayCOSPv2_lmdz.xml
1355            sed -e 's@compression_level="2"@compression_level="0"@' \
1356                $histfile > tmp
1357            \mv -f tmp $histfile
1358            contextfile=context_lmdz.xml
1359            sed -e 's@src="./file_def_histdayCOSP_lmdz.xml"@src="./file_def_histdayCOSPv2_lmdz.xml"@' \
1360                $contextfile > tmp
1361            \mv -f tmp $contextfile
1362            sed -e 's@src="./file_def_histmthCOSP_lmdz.xml"@src="./file_def_histmthCOSPv2_lmdz.xml"@' \
1363                $contextfile > tmp
1364            \mv -f tmp $contextfile
1365            sed -e 's@src="./file_def_histhfCOSP_lmdz.xml"@src="./file_def_histhfCOSPv2_lmdz.xml"@' \
1366                $contextfile > tmp
1367            \mv -f tmp $contextfile
1368            fieldfile=field_def_lmdz.xml
1369            sed -e 's@field_def_cosp1.xml@field_def_cospv2.xml@' $fieldfile \
1370                > tmp
1371            \mv -f tmp $fieldfile
1372        fi
1373
1374        cd ..
1375    fi
1376
1377    # Cas Bensh avec ecrad
1378    if [ "$rad" = "ecrad" ] ; then
1379        cd BENCH${grid_resolution}
1380        cp  ../DefLists/namelist_ecrad .
1381        cp -r ../libf/phylmd/ecrad/data .
1382        cd ..
1383    fi
1384
1385    # Adjusting bench physiq.def to radiative code chosen
1386    cd BENCH${grid_resolution}
1387    sed -e 's/iflag_rrtm=.*.$/iflag_rrtm='$iflag_rrtm'/' \
1388        -e 's/NSW=.*.$/NSW='$NSW'/' physiq.def > tmpdef
1389    \mv tmpdef physiq.def
1390    cd ..
1391
1392    cp $gcm BENCH${grid_resolution}/gcm.e
1393
1394    cd BENCH${grid_resolution}
1395    # On cree le fichier bench.sh au besoin
1396    # Dans le cas 48x36x39 le bench.sh existe deja en parallele
1397
1398    if [ "$grid_resolution" = "48x36x39" ] ; then
1399        echo On ne touche pas au bench.sh
1400        # But we have to adapt "run_local.sh" for $mpirun
1401        sed -e "s@mpirun@$mpirun@g" run_local.sh > tmp
1402        mv -f tmp run_local.sh
1403        chmod u=rwx run_local.sh
1404    elif [ "${parallel:0:3}" = "mpi" ] ; then
1405        # Lancement avec deux procs mpi et 2 openMP
1406        echo "export OMP_STACKSIZE=800M" > bench.sh
1407        if [ "${parallel:4:3}" = "omp" ] ; then
1408            echo "export OMP_NUM_THREADS=2" >> bench.sh
1409        fi
1410        if [ "$cosp" = "v1" -o "$cosp" = "v2" ] ; then
1411            if [ ${hostname:0:5} = jean- ] ; then
1412                   chmod +x ../arch.env
1413                ../arch.env       
1414                echo "ulimit -s 2000000" >> bench.sh
1415            else
1416                echo "ulimit -s 200000" >> bench.sh
1417            fi       
1418        else
1419            echo "ulimit -s unlimited" >> bench.sh
1420        fi
1421        if [ ${hostname:0:5} = jean- ] ; then
1422            . ../arch/arch-${arch}.env
1423            echo "srun -n 2 -A $idris_acct@cpu gcm.e > listing  2>&1" \
1424                 >> bench.sh
1425        else
1426            echo "$mpirun -np 2 gcm.e > listing  2>&1" >> bench.sh
1427        fi
1428        # Add rebuild, using reb.sh if it is there
1429        echo 'if [ -f reb.sh ] ; then' >> bench.sh
1430        echo '  ./reb.sh histday ; ./reb.sh histmth ; ./reb.sh histhf ; ' \
1431             './reb.sh histins ; ./reb.sh stomate_history ; ' \
1432             './reb.sh sechiba_history ; ./reb.sh sechiba_out_2 ' >> bench.sh
1433        echo 'fi' >> bench.sh
1434    else
1435        echo "./gcm.e > listing  2>&1" > bench.sh
1436    fi
1437    # Getting orchidee stuff
1438    if [ $veget == 'CMIP6' ] ; then
1439        #echo 'myget 3DBenchs/BENCHorch11.tar.gz'
1440        #myget 3DBenchs/BENCHorch11.tar.gz
1441        #tar xvzf BENCHorch11.tar.gz
1442        echo 'myget 3DBenchs/BENCHCMIP6.tar.gz'
1443        myget 3DBenchs/BENCHCMIP6.tar.gz
1444        tar xvzf BENCHCMIP6.tar.gz
1445        sed -e "s:VEGET=n:VEGET=y:" config.def > tmp
1446        mv -f tmp config.def
1447        if [ "$with_xios" = "y" ] ; then
1448            cp ../../ORCHIDEE/src_xml/context_orchidee.xml .
1449            echo '<context id="orchidee" src="./context_orchidee.xml"/>' \
1450                 > add.tmp
1451            cp ../../ORCHIDEE/src_xml/field_def_orchidee.xml .
1452            cp ../../ORCHIDEE/src_xml/file_def_orchidee.xml .
1453            cp ../../ORCHIDEE/src_xml/file_def_input_orchidee.xml .
1454            if [ -f ../../ORCHIDEE/src_xml/context_input_orchidee.xml ] ; then
1455                   cp ../../ORCHIDEE/src_xml/context_input_orchidee.xml .
1456                   echo '<context id="orchidee" ' \
1457                     'src="./context_input_orchidee.xml"/>' >> add.tmp
1458            fi
1459            sed -e '/id="LMDZ"/r add.tmp' iodef.xml > tmp
1460            mv tmp iodef.xml
1461            sed -e'{/sechiba1/ s/enabled="_AUTO_"/type="one_file" enabled=".TRUE."/}' \
1462                file_def_orchidee.xml > tmp
1463            \mv -f tmp file_def_orchidee.xml
1464            sed -e 's@enabled="_AUTO_"@type="one_file" enabled=".FALSE."@' \
1465                file_def_orchidee.xml > tmp
1466            \mv -f tmp file_def_orchidee.xml
1467            sed -e 's@output_level="_AUTO_"@output_level="1"@' \
1468                file_def_orchidee.xml > tmp
1469            \mv -f tmp file_def_orchidee.xml
1470            sed -e 's@output_freq="_AUTO_"@output_freq="1d"@' \
1471                file_def_orchidee.xml > tmp
1472            \mv -f tmp file_def_orchidee.xml
1473            sed -e 's@compression_level="4"@compression_level="0"@' \
1474                file_def_orchidee.xml > tmp
1475            \mv -f tmp file_def_orchidee.xml
1476            sed -e 's@XIOS_ORCHIDEE_OK = n@XIOS_ORCHIDEE_OK = y@' \
1477                orchidee.def > tmp
1478            \mv -f tmp orchidee.def
1479        fi
1480    fi
1481
1482    if [[ -f ../arch.env ]]
1483    then
1484        source ../arch.env
1485    fi
1486
1487    echo EXECUTION DU BENCH
1488    set +e
1489    date ; ./bench.sh > out.bench 2>&1 ; date
1490    set -e
1491    tail listing
1492
1493
1494    echo '##########################################################'
1495    echo 'Simulation finished in' `pwd`
1496    echo 'You have compiled with:'
1497    cat ../compile.sh
1498    if [ $parallel = "none" ] ; then
1499        echo 'You may re-run it with : cd ' `pwd` ' ; gcm.e'
1500        echo 'or ./bench.sh'
1501    else
1502        echo 'You may re-run it with : '
1503        echo 'cd ' `pwd` '; ./bench.sh'
1504        #  echo 'ulimit -s unlimited'
1505        #  echo 'export OMP_NUM_THREADS=2'
1506        #  echo 'export OMP_STACKSIZE=800M'
1507        #  echo "$mpirun -np 2 gcm.e "
1508    fi
1509    echo '##########################################################'
1510
1511fi # bench
1512
1513
1514#################################################################
1515# Installation eventuelle du 1D
1516#################################################################
1517
1518if [ $SCM = 1 ] ; then
1519    cd $MODEL
1520    myget 1D/1D.tar.gz
1521    tar xf 1D.tar.gz
1522    cd 1D
1523    if [ $rad = oldrad ] ; then
1524        sed -i'' -e 's/^rad=.*$/rad=oldrad/' run.sh
1525        sed -i'' -e 's/^rad=.*$/rad=oldrad/' bin/compile
1526    fi
1527    echo Running 1D/run.sh, log in `pwd`/run1d.log
1528    ./run.sh > `pwd`/run1d.log 2>&1
1529fi
1530
1531
1532#################################################################
1533# sauvegarde des options veget pour utilisation eventuelle tutorial_prod
1534#################################################################
1535cd $MODEL/modipsl/modeles
1536#echo surface_env file created in $MODEL
1537echo 'veget='$veget > surface_env
1538#opt_veget="-v $veget_version"
1539#echo 'opt_veget="'$opt_veget\" >> surface_env
1540echo 'opt_veget="'-v $veget_version\" >> surface_env
1541echo 'orchidee_rev='$orchidee_rev >> surface_env
1542echo 'suforch='$suff_orc >> surface_env
Note: See TracBrowser for help on using the repository browser.